std::unique_ptr< _Tp, _Dp > Class Template Reference
Pointer Abstractions

## Public Types

typedef _Dp | deleter_type
typedef _Tp | element_type
typedef _Pointer::type | pointer

## Public Member Functions

| unique_ptr (pointer __p) noexcept
| unique_ptr (pointer __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type __d) noexcept
| unique_ptr (pointer __p, typename remove_reference< deleter_type >::type &&__d) noexcept
constexpr | unique_ptr (nullptr_t) noexcept
| unique_ptr (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep , typename = _Require< is_convertible<typename unique_ptr<_Up, _Ep>::pointer, pointer>, __not_<is_array<_Up>>, typename conditional<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>::type>>
| unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
| unique_ptr (const unique_ptr &)=delete
template<typename _Up , typename >
| unique_ptr (auto_ptr< _Up > &&__u) noexcept
pointer | get () const noexcept
deleter_type & | get_deleter () noexcept
const deleter_type & | get_deleter () const noexcept
| operator bool () const noexcept
add_lvalue_reference < element_type >::type | operator* () const
pointer | operator-> () const noexcept
unique_ptr & | operator= (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep >
enable_if< __and_ < is_convertible< typename unique_ptr< _Up, _Ep > ::pointer, pointer >, __not_ < is_array< _Up > > >::value, unique_ptr & >::type | operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
unique_ptr & | operator= (nullptr_t) noexcept
unique_ptr & | operator= (const unique_ptr &)=delete
pointer | release () noexcept
void | reset (pointer __p=pointer()) noexcept
void | swap (unique_ptr &__u) noexcept

## Detailed Description

### template<typename _Tp, typename _Dp = default_delete<_Tp>>
class std::unique_ptr< _Tp, _Dp >

20.7.1.2 unique_ptr for single objects.

Definition at line 109 of file unique_ptr.h.

The documentation for this class was generated from the following files:

- unique_ptr.h
- auto_ptr.h